"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFactory = exports.BuildType = void 0;
const beautify_1 = require("./beautify");
const default_1 = require("./default");
const uglify_1 = require("./uglify");
var BuildType;
(function (BuildType) {
    BuildType[BuildType["DEFAULT"] = 0] = "DEFAULT";
    BuildType[BuildType["UGLIFY"] = 1] = "UGLIFY";
    BuildType[BuildType["BEAUTIFY"] = 2] = "BEAUTIFY";
})(BuildType = exports.BuildType || (exports.BuildType = {}));
const FACTORIES = {
    [BuildType.DEFAULT]: default_1.DefaultFactory,
    [BuildType.UGLIFY]: uglify_1.UglifyFactory,
    [BuildType.BEAUTIFY]: beautify_1.BeautifyFactory
};
function getFactory(type = BuildType.DEFAULT) {
    const factory = FACTORIES[type];
    if (!factory) {
        throw new Error('Unknown build type.');
    }
    return factory;
}
exports.getFactory = getFactory;
