"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UglifyFactory = void 0;
const greybel_transpiler_1 = require("greybel-transpiler");
const inject_imports_1 = require("../utils/inject-imports");
class UglifyFactory extends greybel_transpiler_1.UglifyFactory {
    constructor(options) {
        super(options);
        this.extend();
    }
    extend() {
        this.handlers = Object.assign(Object.assign({}, this.handlers), { BinaryExpression: function (item, _data) {
                if (item.operator === '<<' ||
                    item.operator === '>>' ||
                    item.operator === '>>>' ||
                    item.operator === '|' ||
                    item.operator === '&') {
                    this.pushSegment('bitwise("' + item.operator + '",');
                    this.process(item.left);
                    this.pushSegment(',');
                    this.process(item.right);
                    this.pushSegment(')');
                    return;
                }
                this.process(item.left);
                this.pushSegment(item.operator);
                this.process(item.right);
            }, ImportCodeExpression: function (item, _data) {
                if (!item.emit) {
                    return;
                }
                if (!item.eval) {
                    this.pushSegment(`import_code("${item.directory}")`, item);
                    return;
                }
                const injections = (0, inject_imports_1.injectImport)(this.transformer.context, item);
                for (let index = 0; index < injections.length; index++) {
                    this.pushSegment(injections[index], item);
                    if (index < injections.length - 1)
                        this.eol();
                }
            } });
    }
}
exports.UglifyFactory = UglifyFactory;
