/// <reference types="node" />
import EventEmitter from 'events';
import { Context, ResourceHandler, TargetOptions } from 'greybel-transpiler';
import { ASTChunkGreyScript } from 'greyscript-core';
import { Dependency } from './dependency';
export interface TargetParseResultItem {
    chunk: ASTChunkGreyScript;
    dependency: Dependency;
}
export interface TargetParseResult {
    main: TargetParseResultItem;
    nativeImports: Map<string, TargetParseResultItem>;
}
export declare class Target extends EventEmitter {
    target: string;
    resourceHandler: ResourceHandler;
    context: Context;
    constructor(options: TargetOptions);
    parse(): Promise<TargetParseResult>;
}
