"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.injectImport = void 0;
const greyscript_core_1 = require("greyscript-core");
const context_1 = require("../context");
function injectImport(context, item) {
    const astRefDependencyMap = context.get(context_1.ContextDataProperty.ASTRefDependencyMap);
    const processImportPath = context.getOrCreateData(context_1.ContextDataProperty.ProcessImportPathCallback, () => (item) => item);
    if (!astRefDependencyMap) {
        return [`import_code("${processImportPath(item.directory)}")`];
    }
    const astRefsVisited = context.getOrCreateData(context_1.ContextDataProperty.ASTRefsVisited, () => new Set());
    if (astRefDependencyMap.has(item)) {
        const lines = [];
        const entry = astRefDependencyMap.get(item);
        if (astRefsVisited.has(entry.main.target)) {
            return lines;
        }
        for (const importEntry of entry.imports) {
            if (astRefsVisited.has(importEntry.target))
                continue;
            if (importEntry.ref instanceof greyscript_core_1.ASTImportCodeExpression) {
                lines.push(`import_code("${processImportPath(importEntry.target)}")`);
            }
            astRefsVisited.add(importEntry.target);
        }
        lines.push(`import_code("${processImportPath(entry.main.target)}")`);
        astRefsVisited.add(entry.main.target);
        return lines;
    }
    return [];
}
exports.injectImport = injectImport;
